; Original Barrel Vise macro by Daniels @ 1280x1024 resolution - 02/01/2010

; This modified version by Cegaiel for 1024x768 resolution
;Modifed as follows:
;Set amount of barrels you want to make via dialogue
;GUI status message while the script runs
;Stops stoking towards end and lets heat finish it up (saving a couple/few wood)


; Date: 05/08/2010



; The following should stop runaway macros
; Ctrl+P (Pause) and Ctrl+R (Reload script)
^p::Pause
^r::Reload

; Barrel Vise - Pin window in upper right of screen.
; Coordinates are for Guilded or Public barrel vice (in other words, there should be two lines in the label):
; 1st line is "This is a Barrel Vise", 2nd line: "Usable by ???"
; If the barrel vise you are using is yours and not guilded, then you will temporarily need to change it to Public


; Pin when it is completely empty.

; Ctrl+Alt+W to start the macro
^!w::


IfWinExist eGenesis Client
{


;;;;;;;;;;;;;;;;;;;;;; COORD VARIABLES ;;;;;;;;;;;;;;;;;;;;;;
; Beginning of bar (Edge of black line): 70
; End of bar: 192	

	winX := 80 		; Top of window X/Y Coords, used to select and update the pinned window
	winY := 55
	makeX := 60 		;Make button and also Take X/Y Coords
	makeY := 95
	takeAllX := makeX + 35 
	takeAllY := makeY + 10
	stokeX := 168		; Stoke Button X/Y Coords
	stokeY := 238

	; This is towards the end of progress bar, when it detects blue, it starts looking for the Take... option
	; It also stops stoking, should be enough heat to finish it the last few ticks.
	; Make this about 3 coords (X) from the end of the bar
	ProgressX := 189 
	ProgressY := 220

	; Max Flame wanted, do not have 2 wood in Fuel passed this point.  May need to adjust.
	; Set about 24 coords (X) from the end of bar
	barMaxFlameX := 168 

	bar1WoodX := 71 	; Coord for determining if at least 1 wood is in Fuel (+2 coords from left bar (black area/edge bar)
	bar2WoodX := 78 	; Coord for determining if at least 2 wood is in Fuel (+8 coords from left bar (black area/edge bar)
	
	fuelBarY := 171  	; Y Coord for Fuel bar
	flameBarY := 187 	; Y Coord for Flame bar


	
;;;;;;;;;;;;;;;;;;;;;; MAIN PROGRAM ;;;;;;;;;;;;;;;;;;;;;;


InputBox, Qty, Barrels, How many barrels do you want to make?
counter = 0
totalwood = 0
avgwood = N/A

SetDefaultMouseSpeed, 0
SetMouseDelay, -1


	if (Qty < 0)
	{
	Msgbox, You did not enter a Qty!`n`nExiting...`n`nCtrl+Alt+W to try again
	EXIT
	}


	Gui, +AlwaysOnTop +ToolWindow
	Gui, Font, norm
	Gui, Add, Text, vMineCycleText, Preparing to start ... Standby ...`n`n`n`n`n`n`n`n`n`n
	Gui, Show
	GuiControl, Text, MineCycleText, Preparing to start ... Standby ...`n`n`n`n`n`n`n`n`n`n


	Delay = 10
	;Just a small delay before starting in case we are using the Right Pinup version at same time.
	Loop, %Delay%
	{
	GuiControl, Text, MineCycleText, Script begins in %Delay%s
	Delay --
	Sleep 1000
	}




	Loop, %Qty% ; number of barrels to make
	{
		WinActivate, eGenesis Client
		wood = 0
		done = 0

		;Check that there isn't a barrel (Take... in menu present) from a previous run. If so, Take the barrel first.
		MouseClickCoords(winX, winY)
		ImageSearch, OutputX, OutputY, 12, 87, 56, 103, *50 Take.PNG

		;If Take... menu appears (ErrorLevel 0) then Unload Barrel
		if (ErrorLevel = 0)
		{
GuiControl, Text, MineCycleText, Barrel: %counter% of %qty%`n`nFuel: -`nFlame: -`n`nLast: Unloading Barrel

		;Unload Barrel
		MouseClickCoords(winX, winY)
		sleep 500
		MouseClickCoords(makeX, makeY)
		sleep 500
		MouseClickCoords(takeAllX, takeAllY)
		sleep 500
		MouseClickCoords(winX, winY)
		}



GuiControl, Text, MineCycleText, Barrel: %counter% of %qty%`n`nFuel: -`nFlame: -`n`nLast: Making Barrel

		; Click "Make a barrel"
		MouseClickCoords(winX, winY)
		Sleep 200
		MouseClickCoords(makeX, makeY)
		Sleep 500


		;Search for a popup immediately after clicking "Make Barrel" in case we dont have the ingredients in inventory
		Gosub, SearchPopUpBox



	counter ++

		
		Loop ; Maintain Heat
		{		

			WinActivate, eGenesis Client



			curFuel1 := FindBlue(bar1WoodX, fuelBarY)
			curFuel2 := FindBlue(bar2WoodX, fuelBarY)
			curFlame := FindBlue(barMaxFlameX, flameBarY)
			curProgress := FindBlue(ProgressX, ProgressY)

			if (curFuel2 = 0)
			{
			FuelStatus := 2			
			}
			else if (curFuel1 = 0)
			{
			FuelStatus := 1
			}
			else
			{
			FuelStatus := 0
			}

if (qty > 1 and counter > 1)
{
GuiControl, Text, MineCycleText, Barrel: %counter% of %qty%`n`nFuel: %FuelStatus% Wood`nFlame: %FlameStatus%`n`nLast: %ActionStatus%`n`nWood (This barrel): %wood%`nWood (All barrels): %totalwood%
} else {
GuiControl, Text, MineCycleText, Barrel: %counter% of %qty%`n`nFuel: %FuelStatus% Wood`nFlame: %FlameStatus%`n`nLast: %ActionStatus%`n`nWood (This barrel): %wood%
}

			if (curProgress = 0) ;Stop Stoking, should be enough heat to finish
			{
			ActionStatus := "Waiting for completion"
			FlameStatus := "Cooling down"
			}
			else if (curFlame > 0)
			{					
			FlameStatus := "OK"

				if (curFuel1 > 0) ; Add 2 wood
				{
					MouseClickCoords(stokeX, stokeY)							
					MouseClickCoords(stokeX, stokeY)
					ActionStatus := "Stoke (2 Wood)"
					wood ++
					wood ++
					totalwood ++
					totalwood ++
				}
				else if (curFuel2 > 0) ; Add 1 wood
				{
					MouseClickCoords(stokeX, stokeY)
					ActionStatus := "Stoke (1 Wood)"
					wood ++
					totalwood ++
				}				


			} else {
			FlameStatus := "DANGER"
			ActionStatus := "No Stoke (0 Wood)"
			}


if (qty > 1 and counter > 1)
{
GuiControl, Text, MineCycleText, Barrel: %counter% of %qty%`n`nFuel: %FuelStatus% Wood`nFlame: %FlameStatus%`n`nLast: %ActionStatus%`n`nWood (This barrel): %wood%`nWood (All barrels): %totalwood%
} else {
GuiControl, Text, MineCycleText, Barrel: %counter% of %qty%`n`nFuel: %FuelStatus% Wood`nFlame: %FlameStatus%`n`nLast: %ActionStatus%`n`nWood (This barrel): %wood%
}


				if (curProgress = 0)
				; Close to being done, start looking for "Take..." to appear
				; As soon as it appears, break the loop and move onto the "Unload barrel" routine, below
				{				
				MouseClickCoords(winX, winY)
				ImageSearch, OutputX, OutputY, 12, 87, 56, 103, *50 Take.PNG

				if (ErrorLevel = 0)
				done := 1
				}


			if done = 1
			break

		
		}  ;End Maintain Heat Loop



;This only occurs when after the loop (Maintain Heat) is broken




		;Under rare circumstances (it clicks Stoke a micro second after the barrel completes, a popup could occur.
		;So upon detecing the "Take..." menu appear, it will first see if a popupbox exists and close it before continuing

		Gosub, ClosePopUpBox

GuiControl, Text, MineCycleText, Barrel: %counter% of %qty%`n`nFuel: -`nFlame: -`n`nLast: Unloading Barrel`n`nWood (This barrel): %wood%

		; Unload barrel
		MouseClickCoords(winX, winY)
		sleep 500
		MouseClickCoords(makeX, makeY)
		sleep 500
		MouseClickCoords(takeAllX, takeAllY)
		sleep 500
		MouseClickCoords(winX, winY)

	}

avgwood := (totalwood / qty)
avgwood := Round(avgwood)


if (qty > 1)
{
GuiControl, Text, MineCycleText, Making Barrel: %counter% of %qty%`n`nAll Done!`n`nWood (Last barrel): %wood%`nWood (All barrels): %totalwood%`nAvg wood/barrel: %avgwood%`n`nCtrl+R to reload/reset script
} else {
GuiControl, Text, MineCycleText, Making Barrel: %counter% of %qty%`n`nAll Done!`n`nWood (Last barrel): %wood%`n`nCtrl+R to reload/reset script
}


}


MouseClickCoords(X, Y)
{

;	MouseMove, X, Y
;	sleep 100
;	MouseClick
;	sleep 100
Sleep 100
Click, %X%, %Y%
Sleep 100
}

FindBlue(TX, TY)
{	
	PixelSearch, PX, PY, TX, TY, TX+1, TY+1, 0xFD0606, 55, Fast
	return ErrorLevel
}







		SearchPopUpBox:

		PixelSearch, Px, Py, 529, 481, 529, 481, 0xECDFBD, 15, Fast|RGB

		if ErrorLevel = 0
		{
		MsgBox, Popup box detected, there must be an error somewhere!`n`nReloading/Exiting script...
		RELOAD
		} else {
		return
		}



		ClosePopUpBox:

		PixelSearch, Px, Py, 529, 481, 529, 481, 0xECDFBD, 15, Fast|RGB
		if ErrorLevel = 0
		{
		Click, 529, 481
		Sleep 250
		Click, 529, 481
		Sleep 250
		}
		return

